import React, { PropTypes } from 'react';
import { StyleSheet, Text, View } from 'react-native';

const JSONArrow = ({
  arrowStyle,
  expanded,
  nodeType,
  onClick,
  styling,
}) => (
  <View
    {...styling('arrowContainer', arrowStyle)}
    onClick={onClick}
  >
    <div {...styling(['arrow', 'arrowSign'], nodeType, expanded, arrowStyle)}>
      {'▶'}
      {arrowStyle === 'double' &&
        <div {...styling(['arrowSign', 'arrowSignInner'])}>{'▶'}</div>
      }
    </div>
  </View>
);

JSONArrow.propTypes = {
  styling: PropTypes.func.isRequired,
  arrowStyle: PropTypes.oneOf(['single', 'double']),
  expanded: PropTypes.bool.isRequired,
  nodeType: PropTypes.string.isRequired,
  onClick: PropTypes.func.isRequired
};

JSONArrow.defaultProps = {
  arrowStyle: 'single'
};

export default JSONArrow;
